Coin: SoGeoOrigin Class Reference

| Coin3D is Free Software, published under the BSD 3-clause license. | https://coin3d.github.io https://www.kongsberg.com/en/kogt/

SoGeoOrigin Class Reference
Node Classes

The SoGeoOrigin class is used to specify an absolute geographic location against which geometry is referenced. More...

`#include <Inventor/nodes/SoGeoOrigin.h>`

Inheritance diagram for SoGeoOrigin:

## Public Member Functions
virtual SoType | getTypeId (void) const
| SoGeoOrigin (void)
virtual void | doAction (SoAction *action)
virtual void | callback (SoCallbackAction *action)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | getBoundingBox (SoGetBoundingBoxAction *action)
virtual void | getMatrix (SoGetMatrixAction *action)
virtual void | pick (SoPickAction *action)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)
Public Member Functions inherited from SoNode
void | setOverride (const SbBool state)
SbBool | isOverride (void) const
void | setNodeType (const NodeType type)
NodeType | getNodeType (void) const
virtual SoNode * | copy (SbBool copyconnections=FALSE) const
virtual SbBool | affectsState (void) const
virtual void | GLRenderBelowPath (SoGLRenderAction *action)
virtual void | GLRenderInPath (SoGLRenderAction *action)
virtual void | GLRenderOffPath (SoGLRenderAction *action)
virtual void | handleEvent (SoHandleEventAction *action)
virtual void | rayPick (SoRayPickAction *action)
virtual void | search (SoSearchAction *action)
virtual void | write (SoWriteAction *action)
virtual void | audioRender (SoAudioRenderAction *action)
virtual void | grabEventsSetup (void)
virtual void | grabEventsCleanup (void)
virtual void | startNotify (void)
virtual void | notify (SoNotList *l)
SbUniqueId | getNodeId (void) const
virtual SoChildList * | getChildren (void) const
virtual void | writeInstance (SoOutput *out)
virtual SoNode * | addToCopyDict (void) const
virtual void | copyContents (const SoFieldContainer *from, SbBool copyconnections)
virtual SoFieldContainer * | copyThroughConnection (void) const
Public Member Functions inherited from SoFieldContainer
void | setToDefaults (void)
SbBool | hasDefaultValues (void) const
SbBool | fieldsAreEqual (const SoFieldContainer *container) const
void | copyFieldValues (const SoFieldContainer *container, SbBool copyconnections=FALSE)
SbBool | set (const char *const fielddata)
void | get (SbString &fielddata)
virtual int | getFields (SoFieldList &l) const
virtual int | getAllFields (SoFieldList &l) const
virtual SoField * | getField (const SbName &name) const
virtual SoField * | getEventIn (const SbName &name) const
virtual SoField * | getEventOut (const SbName &name) const
SbBool | getFieldName (const SoField *const field, SbName &name) const
SbBool | enableNotify (const SbBool flag)
SbBool | isNotifyEnabled (void) const
SbBool | set (const char *fielddata, SoInput *input)
void | get (SbString &fielddata, SoOutput *out)
virtual SbBool | validateNewFieldValue (SoField *field, void *newval)
virtual void | addWriteReference (SoOutput *out, SbBool isfromfield=FALSE)
SbBool | getIsBuiltIn (void) const
virtual void | getFieldsMemorySize (size_t &managed, size_t &unmanaged) const
void | setUserData (void *userdata) const
void * | getUserData (void) const
Public Member Functions inherited from SoBase
void | ref (void) const
void | unref (void) const
void | unrefNoDelete (void) const
int32_t | getRefCount (void) const
void | touch (void)
SbBool | isOfType (SoType type) const
| Returns `TRUE` if the type of this object is either of the same type or inherited from type.
virtual SbName | getName (void) const
virtual void | setName (const SbName &newname)
void | addAuditor (void *const auditor, const SoNotRec::Type type)
void | removeAuditor (void *const auditor, const SoNotRec::Type type)
const SoAuditorList & | getAuditors (void) const
SbBool | shouldWrite (void)
void | assertAlive (void) const

## Static Public Member Functions
static SoType | getClassTypeId (void)
static void | initClass (void)
Static Public Member Functions inherited from SoNode
static uint32_t | getCompatibilityTypes (const SoType &nodetype)
static SoType | getClassTypeId (void)
static SoNode * | getByName (const SbName &name)
static int | getByName (const SbName &name, SoNodeList &l)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static void | initClasses (void)
static SbUniqueId | getNextNodeId (void)
static int | getActionMethodIndex (const SoType type)
static void | getBoundingBoxS (SoAction *action, SoNode *node)
static void | GLRenderS (SoAction *action, SoNode *node)
static void | callbackS (SoAction *action, SoNode *node)
static void | getMatrixS (SoAction *action, SoNode *node)
static void | handleEventS (SoAction *action, SoNode *node)
static void | pickS (SoAction *action, SoNode *node)
static void | rayPickS (SoAction *action, SoNode *node)
static void | searchS (SoAction *action, SoNode *node)
static void | writeS (SoAction *action, SoNode *node)
static void | audioRenderS (SoAction *action, SoNode *node)
static void | getPrimitiveCountS (SoAction *action, SoNode *node)
Static Public Member Functions inherited from SoFieldContainer
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType | getClassTypeId (void)
| This static method returns the SoType object associated with objects of this class.
static void | cleanupClass (void)
static void | initCopyDict (void)
static void | addCopy (const SoFieldContainer *orig, const SoFieldContainer *copy)
static SoFieldContainer * | checkCopy (const SoFieldContainer *orig)
static SoFieldContainer * | findCopy (const SoFieldContainer *orig, const SbBool copyconnections)
static void | copyDone (void)
Static Public Member Functions inherited from SoBase
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType | getClassTypeId (void)
| This static method returns the SoType object associated with objects of this class.
static void | addName (SoBase *const base, const char *const name)
static void | removeName (SoBase *const base, const char *const name)
static void | incrementCurrentWriteCounter (void)
static void | decrementCurrentWriteCounter (void)
static SoBase * | getNamedBase (const SbName &name, SoType type)
static int | getNamedBases (const SbName &name, SoBaseList &baselist, SoType type)
static SbBool | read (SoInput *input, SoBase *&base, SoType expectedtype)
static void | setInstancePrefix (const SbString &c)
static void | setTraceRefs (SbBool trace)
static SbBool | getTraceRefs (void)
static SbBool | connectRoute (SoInput *input, const SbName &fromnodename, const SbName &fromfieldname, const SbName &tonodename, const SbName &tofieldname)
static SbBool | readRoute (SoInput *input)

## Public Attributes
SoSFVec3d | geoCoords
SoMFString | geoSystem

## Protected Member Functions
virtual const SoFieldData * | getFieldData (void) const
virtual | ~SoGeoOrigin ()
Protected Member Functions inherited from SoNode
| SoNode (void)
virtual | ~SoNode ()
virtual SbBool | readInstance (SoInput *in, unsigned short flags)
Protected Member Functions inherited from SoFieldContainer
| SoFieldContainer (void)
virtual | ~SoFieldContainer ()
Protected Member Functions inherited from SoBase
| SoBase (void)
virtual | ~SoBase ()
virtual void | destroy (void)
SbBool | hasMultipleWriteRefs (void) const
SbBool | writeHeader (SoOutput *out, SbBool isgroup, SbBool isengine) const
void | writeFooter (SoOutput *out) const
virtual const char * | getFileFormatName (void) const
virtual SoNotRec | createNotRec (void)

## Static Protected Member Functions
static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoNode
static const SoFieldData ** | getFieldDataPtr (void)
static void | setNextActionMethodIndex (int index)
static int | getNextActionMethodIndex (void)
static void | incNextActionMethodIndex (void)
static void | setCompatibilityTypes (const SoType &nodetype, const uint32_t bitmask)
Static Protected Member Functions inherited from SoBase
static uint32_t | getCurrentWriteCounter (void)
static void | staticDataLock (void)
static void | staticDataUnlock (void)

## Additional Inherited Members
Public Types inherited from SoNode
enum | NodeType { INVENTOR = 0x0000 , VRML1 = 0x0001 , VRML2 = 0x0002 , INVENTOR_1 = 0x0004 , INVENTOR_2_0 = 0x0008 , INVENTOR_2_1 = 0x0010 , INVENTOR_2_5 = 0x0020 , INVENTOR_2_6 = 0x0040 , COIN_1_0 = 0x0080 , COIN_2_0 = 0x0100 , EXTENSION = 0x0200 , COIN_2_2 = 0x0400 , COIN_2_3 = 0x0800 , COIN_2_4 = 0x1000 , INVENTOR_5_0 = 0x2000 , COIN_2_5 = 0x4000 , COIN_3_0 = 0x8000 , INVENTOR_6_0 = 0x10000 , COIN_4_0 = 0x20000 }
Protected Types inherited from SoBase
enum | BaseFlags { IS_ENGINE = 0x01 , IS_GROUP = 0x02 }
Protected Attributes inherited from SoNode
SbUniqueId | uniqueId
Protected Attributes inherited from SoFieldContainer
SbBool | isBuiltIn
Static Protected Attributes inherited from SoNode
static SbUniqueId | nextUniqueId = 1
static int | nextActionMethodIndex = 0

## Detailed Description

The SoGeoOrigin class is used to specify an absolute geographic location against which geometry is referenced.

FILE FORMAT/DEFAULTS:

GeoOrigin {
geoSystem ["GD", "WE"]
geoCoords 0 0 0
}
SoGeoOrigin::geoCoords
SoSFVec3d geoCoords
Definition SoGeoOrigin.h:52
SoGeoOrigin::geoSystem
SoMFString geoSystem
Definition SoGeoOrigin.h:53

A common problem when dealing with geographic data is the reduced floating point precision you often get. UTM coordinates are often in the 10^5 a 10^6 magnitude, and this leaves very little precision for details at that position.

The SoGeo nodes are therefore useful when you want to keep your data in its original system, but still get good floating point precision when rendering.

Coin needs a local Cartesian coordinate system when rendering. When a SoGeoOrigin node is used, Coin will create a coordinate system at the SoGeoOrigin position, and all geometry (and the camera) in the scene graph will be projected into that coordinate system.

The coordinate system will always have the Z-axis point up from the ground. The Y-axis will point towards the north pole, and the X-axis is found using the right hand rule.

A scene graph should only contain one GeoOrigin node, and all geometry in the scene graph will, as stated earlier, be rendered relative to this position. This means that the precision will be best if the GeoOrigin position is as close to actual camera position as possible. If you move around on a large area, it might therefore be a good idea too actually move the GeoOrigin position instead of the camera.

To place geometry in the scene graph, you can either use an SoGeoSeparator node or an SoGeoCoordinate node. When using a GeoSeparator node, all geometry inside that separator will be rendered relative to its geo-system position and orientation, and you then use regular shapes and regular SoCoordinate3 nodes to specify data (the points in an SoCoordinate3 must be adjusted to be relative to the GeoSeparator position).

The SoGeoCoordinate node on the other hand can contain double precision geo-coordinates, and that node will internally recalculate the double precision array to a single precision array which is relative to the SoGeoOrgin node.

One note regarding UTM projections: Since it is quite common to assume a flat earth when working with UTM data, it is possible to supply a "FLAT" keyword for UTM coordinate systems:

GeoOrigin {
geoSystem [ "UTM", "Z17", "FLAT" ]
geoCoords 846889 4313850 0
}

Example scene graph:

GeoOrigin { geoSystem "GD" geoCoords 40.77 -73.97 0 }
GeoSeparator {
# New York, NY
geoSystem "GD"
geoCoords 40.67 -73.94 0
BaseColor { rgb 0 1 0 }
Cube { width 25000 height 25000 depth 25000 }
Translation { translation 0 0 30000 }
Text2 { string "New York" }
}
GeoSeparator {
# Los Angeles, CA
geoSystem "GD"
geoCoords 34.11 -118.4 0
BaseColor { rgb 1 0 0 }
Cube { width 25000 height 25000 depth 25000 }
Translation { translation 0 0 30000 }
Text2 { string "Los Angeles" }
}
GeoSeparator {
# Washington, DC
geoSystem [ "UTM", "Z17" ]
geoCoords 846889 4313850 0
BaseColor { rgb 0 1 1 }
Cube { width 25000 height 25000 depth 25000 }
Translation { translation 0 0 30000 }
Text2 { string "Washington" }
}
# add a small geogrid
GeoCoordinate {
geoSystem "GD"
point [
32 -120 0,
32 -110 0,
32 -100 0,
32 -90 0,
32 -80 0,
32 -70 0,
34 -120 0,
34 -110 0,
34 -100 0,
34 -90 0,
34 -80 0,
34 -70 0,
36 -120 0,
36 -110 0,
36 -100 0,
36 -90 0,
36 -80 0,
36 -70 0,
38 -120 0,
38 -110 0,
38 -100 0,
38 -90 0,
38 -80 0,
38 -70 0,
40 -120 0,
40 -110 0,
40 -100 0,
40 -90 0,
40 -80 0,
40 -70 0
42 -120 0,
42 -110 0,
42 -100 0,
42 -90 0,
42 -80 0,
42 -70 0
]
}
DrawStyle { style LINES }
BaseColor {}
ShapeHints { vertexOrdering COUNTERCLOCKWISE }
QuadMesh { verticesPerRow 6 verticesPerColumn 6 }

Since
  Coin 2.5

## Constructor & Destructor Documentation

## ◆ SoGeoOrigin()

SoGeoOrigin::SoGeoOrigin | ( | void |  | ) |

Constructor.

## ◆ ~SoGeoOrigin()

SoGeoOrigin::~SoGeoOrigin | ( |  | ) |
| protectedvirtual

Destructor.

## Member Function Documentation

## ◆ getClassTypeId()

SoType SoGeoOrigin::getClassTypeId | ( | void |  | ) |
| static

This static method returns the SoType object associated with objects of this class.

## ◆ getTypeId()

SoType SoGeoOrigin::getTypeId | ( | void |  | ) | const
| virtual

Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and "downward" casting.

Implements SoBase.

## ◆ getFieldDataPtr()

const SoFieldData ** SoGeoOrigin::getFieldDataPtr | ( | void |  | ) |
| staticprotected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Returns the SoFieldData class which holds information about fields in this node.

## ◆ getFieldData()

const SoFieldData * SoGeoOrigin::getFieldData | ( | void |  | ) | const
| protectedvirtual

Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns `NULL`.

Reimplemented from SoFieldContainer.

## ◆ initClass()

void SoGeoOrigin::initClass | ( | void |  | ) |
| static

## ◆ doAction()

void SoGeoOrigin::doAction | ( | SoAction * | action | ) |
| virtual

This function performs the typical operation of a node for any action.

Reimplemented from SoNode.

## ◆ callback()

void SoGeoOrigin::callback | ( | SoCallbackAction * | action | ) |
| virtual

Action method for SoCallbackAction.

Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph.

Reimplemented from SoNode.

## ◆ GLRender()

void SoGeoOrigin::GLRender | ( | SoGLRenderAction * | action | ) |
| virtual

Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or want to throw geometry primitives at OpenGL override this method.

Reimplemented from SoNode.

## ◆ getBoundingBox()

void SoGeoOrigin::getBoundingBox | ( | SoGetBoundingBoxAction * | action | ) |
| virtual

Action method for the SoGetBoundingBoxAction.

Calculates bounding box and center coordinates for node and modifies the values of the action to encompass the bounding box for this node and to shift the center point for the scene more towards the one for this node.

Nodes influencing how geometry nodes calculate their bounding box also override this method to change the relevant state variables.

Reimplemented from SoNode.

## ◆ getMatrix()

void SoGeoOrigin::getMatrix | ( | SoGetMatrixAction * | action | ) |
| virtual

Action method for SoGetMatrixAction.

Updates action by accumulating with the transformation matrix of this node (if any).

Reimplemented from SoNode.

## ◆ pick()

void SoGeoOrigin::pick | ( | SoPickAction * | action | ) |
| virtual

Action method for SoPickAction.

Does common processing for SoPickAction action instances.

Reimplemented from SoNode.

## ◆ getPrimitiveCount()

void SoGeoOrigin::getPrimitiveCount | ( | SoGetPrimitiveCountAction * | action | ) |
| virtual

Action method for the SoGetPrimitiveCountAction.

Calculates the number of triangle, line segment and point primitives for the node and adds these to the counters of the action.

Nodes influencing how geometry nodes calculate their primitive count also override this method to change the relevant state variables.

Reimplemented from SoNode.

## Member Data Documentation

## ◆ geoCoords

SoSFVec3d SoGeoOrigin::geoCoords

Used for specifying the geographic coordinates. For the GD system this should be <latitude> <longitude> <elevation>. For UTM it is <easting> <northing> <elevation>, and for GC it is simply <x> <y> <z>.

## ◆ geoSystem

SoMFString SoGeoOrigin::geoSystem

Used to specify a spatial reference frame. Coin currently supports three different systems. Support for more systems might be added in the future.

- "GD" - The Geodetic system (latitude/longitude).

- "UTM" - Universal Transverse Mercator coordinate system. The second string should be the zone, encoded as "Z<n>".

- "GC" - Earth-fixed Geocentric with respect to the WGS84 ellipsoid.

The "GD" and "UTM" systems can, for future support, have an ellipsoid specification. The default is "WE" which is the WGS84 ellipsoid, the only ellipsoid currently supported in Coin.

The documentation for this class was generated from the following files:

- SoGeoOrigin.h
- SoGeoOrigin.cpp